// import Nevow.Athena

Nevow.Athena.Widget.subclass(EchoThing,'EchoWidget').methods(
    function __init__(self, node) {
        EchoThing.EchoWidget.upcall(self, "__init__", node);
    },  

    function delText(self, item, name) {
        /*var oldNode = document.getElementById(name);*/
        var oldNode = self.nodeByAttribute('name', name);
        var thing = self.nodeByAttribute('name', item);
        thing.removeChild(oldNode);
        delete oldNode;
        /* do we have to delete the object completely?*/
    },

    function addText(self, kind, item, text, name) {
        var newNode = document.createElement(kind);
        var thing = self.nodeByAttribute('name', item);
        newNode.setAttribute('name', name);
        newNode.id=name;
        newNode.appendChild(document.createTextNode(text));
        thing.appendChild(newNode);
    },
 
    function stackText(self, kind, item, text, name, location) {
        var newNode = document.createElement(kind);
        /*var oldNode = document.getElementById(location);*/
        var oldNode = self.nodeByAttribute('name', name);
        var thing = self.nodeByAttribute('name', item);
        newNode.setAttribute('name', name);
        newNode.id=name;
        newNode.appendChild(document.createTextNode(text));
        thing.insertBefore(newNode,oldNode);
    },
 
    function stackElement(self, kind, style, item, text, name, location) {
        var newNode = document.createElement(kind);
        /*var oldNode = document.getElementById(location);*/
        var oldNode = self.nodeByAttribute('name', location);
        var thing = self.nodeByAttribute('name', item);
        newNode.setAttribute('style', style);
        newNode.setAttribute('name', name);
        newNode.id=name;
        newNode.appendChild(document.createTextNode(text));
        thing.insertBefore(newNode,oldNode);
    },

    function addImage(self, item, location, name) {
        var newNode = document.createElement("img");
        var thing = self.nodeByAttribute('name', item);
        newNode.setAttribute('name', name);
        newNode.setAttribute('src', location);
        thing.appendChild(newNode);
    },

    function addRow(self, item, name) {
        var thing = self.nodeByAttribute('name', item);
        var tBody = thing.getElementsByTagName('tbody')[0];
        var newTR = document.createElement('tr');
        tBody.appendChild(newTR);
    },

    function removeRows(self, item) {
        var thing = self.nodeByAttribute('name', item);
        for (var i=thing.rows.length;i>0;i--) {
            thing.deleteRow(i-1);
          }
    },

    function addElement(self, kind, style, item, text, name) {
        var newNode = document.createElement(kind);
        var thing = self.nodeByAttribute('name', item);
        newNode.setAttribute('style', style);
        newNode.setAttribute('name', name);
        newNode.id=name;
        newNode.appendChild(document.createTextNode(text));
        thing.appendChild(newNode);
    },

    function changeElement(self, attr, value, item) {
        var thing = self.nodeByAttribute('name', item);
        thing.setAttribute(attr, value);
    },

    function selected(self, item) {
       self.cursor_wait();
       self.callRemote('select', item);
    },

    function selected2(self, item) {
       self.cursor_wait();
       self.callRemote('select2', item);
    },

    function selected3(self, item) {
       self.cursor_wait();
       self.callRemote('select3', item);
    },

    function cursor_wait(self) {
       document.body.style.cursor = 'wait';
       document.bgColor = '#C0C0C0';
    },

    // Returns the cursor to the default pointer
    function cursor_clear(self) {
       document.body.style.cursor = 'default';
       document.bgColor = 'white';
    }


);


